import multiprocessing, time, os
import numpy as N
import pylab
import scipy.fftpack as fft

#TODO: add gnuradio
#TODO: make zoom of fft better ... recalculate to a given zoom

def startGQRX(table):
    if False:
        for ii in table:
            gqrx = multiprocessing.Process(target=doGQRX,args=(ii[0],ii[1],ii[2],ii[3]))
            gqrx.start()
    else:
        for ii in table:
            doGQRX(ii[0],ii[1],ii[2],ii[3])

def startFFT(table):
    if True:
        for ii in table:
            fft = multiprocessing.Process(target=doFFT,args=(ii[0],ii[1],ii[2],ii[3]))
            fft.start()
    else:
        for ii in table:
            doFFT(ii[0],ii[1],ii[2],ii[3])

def doFFT(freq,cfreq,date,fn):
    raw_bytes = N.load('SavedSignals/'+fn)
    data = N.empty(len(raw_bytes)/2, 'complex')
    data.real, data.imag = raw_bytes[::2], raw_bytes[1::2]
    data /= (255.0/2)
    data -= (1 + 1j)
    F = N.roll(N.abs(fft.fft(N.reshape(data,(-1,1024))))**2,512)
    
    dF=(2e6/1024.0)
    xx=(cfreq+(N.arange(1024)-512)*dF)/1e6
    tmp=N.arange(len(raw_bytes)/(2*1024))*1024/2e6
    pylab.figure('%4.3f MHz'%(freq/1e6))
    date = time.strftime('%y%m%d: %H:%M',time.localtime(date))
    pylab.title('%4.3f MHz %s'%(freq/1e6,date))
    pylab.xlabel('Freq [MHz]')
    pylab.ylabel('Time [s]')
    pylab.pcolormesh(xx,tmp,N.log(F+1))
    pylab.show()

def doGQRX(freq,cfreq,date,fn):
    raw_bytes = N.load('SavedSignals/'+fn)
    data = N.empty(len(raw_bytes), 'float32')
    data = raw_bytes[:]
    data = data/(255.0/2.0)
    data = data-1.0
    data = data*0.01
    #data = data -N.mean(data)

    from array import array
    gqrxfn = 'SavedSignals/'+fn+'.gqrx'
    output_file = open(gqrxfn, 'wb')
    float_array = array('f', data)
    float_array.tofile(output_file)
    output_file.close()
    
    cfile = open(gqrxfn+'.conf', 'w')
    cfile.write("""[General]
configversion=2
crashed=false

[gui]
geometry=@ByteArray(\\x1\\xd9\\xd0\\xcb\\0\\x1\\0\\0\\0\\0\\0\\x41\\0\\0\\0\\x18\\0\\0\\x4\\n\\0\\0\\x2\\x9f\\0\\0\\0K\\0\\0\\0>\\0\\0\\x4\\0\\0\\0\\x2\\x95\\0\\0\\0\\0\\0\\0)
state=@ByteArray(\\0\\0\\0\\xff\\0\\0\\0\\0\\xfd\\0\\0\\0\\x1\\0\\0\\0\\x1\\0\\0\\0\\xfa\\0\\0\\x2\\x1a\\xfc\\x2\\0\\0\\0\\x2\\xfc\\0\\0\\0(\\0\\0\\0\\xfa\\0\\0\\0\\xc0\\0\\b\\0\\x1d\\xfa\\0\\0\\0\\x1\\x2\\0\\0\\0\\x2\\xfb\\0\\0\\0\\x18\\0\\x44\\0o\\0\\x63\\0k\\0I\\0n\\0p\\0u\\0t\\0\\x43\\0t\\0l\\x1\\0\\0\\0\\0\\xff\\xff\\xff\\xff\\0\\0\\0\\x96\\0\\xff\\xff\\xff\\xfb\\0\\0\\0\\x12\\0\\x44\\0o\\0\\x63\\0k\\0R\\0x\\0O\\0p\\0t\\x1\\0\\0\\0\\0\\xff\\xff\\xff\\xff\\0\\0\\0\\xa2\\0\\a\\xff\\xff\\xfc\\0\\0\\x1(\\0\\0\\x1\\x1a\\0\\0\\0\\xfa\\x1\\0\\0\\x1d\\xfa\\0\\0\\0\\x1\\x2\\0\\0\\0\\x2\\xfb\\0\\0\\0\\xe\\0\\x44\\0o\\0\\x63\\0k\\0\\x46\\0\\x66\\0t\\x1\\0\\0\\0\\0\\xff\\xff\\xff\\xff\\0\\0\\0\\x96\\0\\xff\\xff\\xff\\xfb\\0\\0\\0\\x12\\0\\x44\\0o\\0\\x63\\0k\\0\\x41\\0u\\0\\x64\\0i\\0o\\x1\\0\\0\\0\\0\\xff\\xff\\xff\\xff\\0\\0\\0\\xdc\\0\\xff\\xff\\xff\\0\\0\\x2\\xb6\\0\\0\\x2\\x1a\\0\\0\\0\\x4\\0\\0\\0\\x4\\0\\0\\0\\b\\0\\0\\0\\b\\xfc\\0\\0\\0\\x1\\0\\0\\0\\x2\\0\\0\\0\\x1\\0\\0\\0\\x16\\0m\\0\\x61\\0i\\0n\\0T\\0o\\0o\\0l\\0\\x42\\0\\x61\\0r\\x1\\0\\0\\0\\0\\xff\\xff\\xff\\xff\\0\\0\\0\\0\\0\\0\\0\\0)

[input]
device="file=%s,freq=%i,rate=2000000,repeat=true,throttle=true"
frequency=%i
sample_rate=2000000

[receiver]
demod=3
offset=24100

[audio]
gain=-200
"""%(os.path.abspath(gqrxfn),cfreq,cfreq))
    cfile.close()
    os.system("gqrx -c %s"%(os.path.abspath(gqrxfn+'.conf')))
    os.remove(gqrxfn)
    os.remove(gqrxfn+'.conf')
