#!/usr/bin/python

# TODO: Install script
# TODO: Figure out how to get error messages from multiprocess to print ...

import multiprocessing, argparse, sys, time, os
import database
try:
    import radio
    hasRadio = True
except:
    hasRadio = False
try:
    import GUI
    hasNpyscreen = True
except:
    hasNpyscreen = False

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description="""SDR scanning application starting RTL scanning, database and GUI.""")
    parser.add_argument("--verbose","-v",help="Print a lot ...",
                        action="store_true")
    group = parser.add_mutually_exclusive_group()
    group.add_argument("--radio","-r",help="Only start radio part",
                        action="store_true")
    group.add_argument("--db","-d",help="Only start database part",
                        action="store_true")
    group.add_argument("--gui","-g",help="Only start gui part",
                        action="store_true")
    parser.add_argument("--port","-p",default=7919,help="Port number for communication with database.",type=int)
    parser.add_argument("--cal","-c",default=None,help="Frequency [MHz] to calibrate to (max ppm error 300).",
                        type=float)
    parser.add_argument("--snr","-s",default=20.0,help="Min SNR",type=float)
    args = parser.parse_args()
    startAll = not (args.db or args.gui or args.radio)

    if startAll or args.db:
        database.StartDB(args.port,verbose=args.verbose)
        time.sleep(1)
    
    db=database.server(args.port,start=False,verbose=args.verbose)
    if db.serverPort==None:
        sys.exit('Database server not found')

    if startAll or args.radio:
        print "Starting radios"
        try: os.mkdir('SavedSignals')
        except: pass
        for ii in range(1):
            radio.start(device=ii,serverPort=db.serverPort,calFreq=args.cal,verbose=args.verbose,snr=args.snr)
            #try:
            #    radio.start(device=ii,serverPort=db.serverPort)
            #    print "Successfully started device %i"%ii
            #except:
            #    pass

    if startAll or args.gui:
        GUI.main(db.serverPort)
        
